package eu.mhsl.craftattack.spawn.varo.appliances.metaGameplay.varoDeath;

import eu.mhsl.craftattack.spawn.core.Main;
import eu.mhsl.craftattack.spawn.core.appliance.Appliance;
import eu.mhsl.craftattack.spawn.core.util.text.DisconnectInfo;
import eu.mhsl.craftattack.spawn.varo.appliances.metaGameplay.teams.Teams;
import net.kyori.adventure.text.Component;
import net.kyori.adventure.text.serializer.plain.PlainTextComponentSerializer;
import org.bukkit.entity.Player;
import org.bukkit.event.Listener;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

import java.util.List;
import java.util.Objects;

public class VaroDeath extends Appliance {
    public void registerPlayerDeath(Player player, @Nullable Component component) {
        String deathMessage = PlainTextComponentSerializer.plainText().serialize(Objects.requireNonNull(component));
        DisconnectInfo disconnectInfo = new DisconnectInfo(
            deathMessage,
            "Du bist gestorben, und bist daher aus dem Projekt ausgeschieden!",
            "Vielen Dank für deine Teilnahme",
            player.getUniqueId()
        );

        //TODO send player death to backend

        disconnectInfo.applyKick(player);
        Main.instance().getAppliance(Teams.class).refreshTeamList();
    }

    @Override
    protected @NotNull List<Listener> listeners() {
        return List.of(
            new PlayerDeathListener()
        );
    }
}
